/**
 * @file parenthesis.c
 */

#include <stdio.h>
#include <string.h>

#include "stack.h"

int main()
{
    char str[256];
    char *p;
    struct stack _s, *s = &_s;
    int ok, ch;

    while (fgets(str, sizeof(str), stdin) && strlen(str) > 1) {
	for (empty(s), ok = 1, p = str; ok && *p && *p != '\n'; p++) {
	    switch (*p) {
	    case '[':
	    case '(':
		if (push(s, *p) < 0) {
		    printf("error: out of stack space\n");
		    ok = 0;
		    break;
		}
		break;
	    case ')':
	    case ']':
		if (pop(s, &ch) < 0) {
		    printf("error: too many closing brackets\n");
		    ok = 0;
		    break;
		}
		if ((ch == '(' && *p != ')')
		    || (ch == '[' && *p != ']')) {
		    printf("error: closing bracket does not match opening bracket\n");
                    ok = 0;
		    break;
		}
		break;
	    default:
		continue;
	    }
	}
	if (ok) {
	    printf("%s\n", isEmpty(s) ? "ok" : "error: not enough closing brackets");
	}
    }

    return 0;
}
